
structure Top :> TOP =
struct

    fun loop_eval () = 
        (Loop.loop (Loop.eval Loop.showType)) 
        handle Parse.ParseError s => print ("Parse Error: " ^ s ^ "\n");

    fun loop_type () = 
        (Loop.loop Loop.showType)
        handle Parse.ParseError s => print ("Parse Error: " ^ s ^ "\n");

    fun loop_print () =
        (Loop.loop Loop.show)
        handle Parse.ParseError s => print ("Parse Error: " ^ s ^ "\n");


    fun file_print f =
        (Loop.loopFile f Loop.show)
        handle Parse.ParseError s => print ("Parse Error: " ^ s ^ "\n");

    fun file_type  f = 
        (Loop.loopFile f Loop.showType)
        handle Parse.ParseError s => print ("Parse Error: " ^ s ^ "\n");

    fun file_eval  f =
        (Loop.loopFile f (Loop.eval Loop.showType)) 
        handle Parse.ParseError s => print ("Parse Error: " ^ s ^ "\n");

end