structure Typing :> TYPING =
struct

  open MinML

  exception TypeError

  (* Make sure two types are the same. *)

  fun equal (t,t') = ...

  (* The empty environment. *)

  val empty = ...

  type (''a, 'b) env = ...

  (* ++ : (''a, 'b) env * (''a * 'b) -> (''a, 'b) env 
	  g ++ (x,t) adds a variable x with type t to environment g. *)

  infix 1 ++
  fun (g ++ (x,t)) = ...

  (* typing : (string, typ) env * exp -> typ
     typing(g,e) returns the type of e in context g, or raises
     TypeError if e has no type in context g. *)

  fun typing (g,e) = ...


























  (* these are already complete, given a working typing function *)

  fun typeOf e = typing(empty,e)
  fun typeOpt e = SOME (typeOf e) handle TypeError => NONE

end
