signature TYPING =
sig

  exception TypeError

  (* computes the type of an expression, or raises TypeError if
     no type exists *)
  val typeOf : MinML.exp -> MinML.typ

  (* ... NONE if no type exists *)
  val typeOpt : MinML.exp -> MinML.typ option

end
